<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib uri="http://wso2.org/projects/carbon/taglibs/carbontags.jar" prefix="carbon" %>
<%@ page import="org.wso2.carbon.utils.ServerConstants" %>
<%@ page import="org.apache.axis2.context.ConfigurationContext" %>
<%@ page import="org.wso2.carbon.ui.CarbonUIUtil" %>
<%@ page import="org.wso2.carbon.CarbonConstants" %>
<%@ page import="org.wso2.carbon.dataservices.ui.beans.Config" %>
<%@ page import="java.util.ArrayList" %>
<%@ page import="java.util.Iterator" %>
<%@ page import="org.wso2.carbon.dataservices.ui.beans.Property" %>
<%@ page import="org.wso2.carbon.dataservices.DBConstants" %>
<%@ page import="org.wso2.carbon.dataservices.ui.Utils" %>

<fmt:bundle basename="org.wso2.carbon.dataservices.ui.i18n.Resources">
<!-- 
<carbon:breadcrumb
        label="Add Data Source"
        resourceBundle="org.wso2.carbon.dataservices.ui.i18n.Resources"
        topPage="false"
        request="<%=request%>"/>
        -->
<jsp:useBean id="dataService" class="org.wso2.carbon.dataservices.ui.beans.Data" scope="session">
</jsp:useBean>
<script type="text/javascript" src="js/ui-validations.js"></script>
<%
    //retrieve value from serviceDetails.jsp
    String name = request.getParameter("name");
    String description = request.getParameter("description");
    String configId = request.getParameter("configId");
    String selectedType = request.getParameter("selectedType");
    String flag = request.getParameter("flag");
    boolean readOnly = false;
    if(flag == null){
        flag = "";
    }
    if (configId != null && configId.trim().length() > 0) {
        Config dsConfig = dataService.getConfig(configId);
        if (dsConfig == null) {
            //This is a request for addding new datasource
            //Observe selectedType & populate
            if (selectedType != null && selectedType.trim().length() > 0) {
                Config newConfig = new Config();
                newConfig.setId(configId);
                if ("RDBMS".equals(selectedType)) {
                    newConfig.addProperty("org.wso2.ws.dataservice.driver", "");
                    newConfig.addProperty("org.wso2.ws.dataservice.protocol", "");
                    newConfig.addProperty("org.wso2.ws.dataservice.user", "");
                    newConfig.addProperty("org.wso2.ws.dataservice.password", "");
                    newConfig.addProperty("org.wso2.ws.dataservice.minpoolsize", "");
                    newConfig.addProperty("org.wso2.ws.dataservice.maxpoolsize", "");
                    newConfig.addProperty("org.wso2.ws.dataservice.autocommit", "");
                    
                } else if ("EXCEL".equals(selectedType)) {
                    newConfig.addProperty("excel_datasource", "");

                } else if ("CSV".equals(selectedType)) {
                    newConfig.addProperty("csv_datasource", "");
                    newConfig.addProperty("csv_columnseperator", ",");
                    newConfig.addProperty("csv_columns", "");
                    newConfig.addProperty("csv_columnordinal", "");
                    newConfig.addProperty("csv_startingrow", "");
                    newConfig.addProperty("csv_maxrowcount", "-1");
                    newConfig.addProperty("csv_hasheader", "");
                } else if ("JNDIDatasource".equals(selectedType)) {
                    newConfig.addProperty("jndi_context_class", "");
                    newConfig.addProperty("jndi_provider_url", "");
                    newConfig.addProperty("jndi_resource_name", "");
                    newConfig.addProperty("jndi_username", "");
                    newConfig.addProperty("jndi_password", "");

                }
                dataService.setConfig(newConfig);
            }
        }else{
        	readOnly = true;
            if(!flag.equals("")){
                dataService.removeConfig(dsConfig);
                Config conf = new Config();
                conf.setId(configId);
            if ("RDBMS".equals(selectedType)){
                    conf.addProperty("org.wso2.ws.dataservice.driver", "");
                    conf.addProperty("org.wso2.ws.dataservice.protocol", "");
                    conf.addProperty("org.wso2.ws.dataservice.user", "");
                    conf.addProperty("org.wso2.ws.dataservice.password", "");
                    conf.addProperty("org.wso2.ws.dataservice.minpoolsize", "");
                    conf.addProperty("org.wso2.ws.dataservice.maxpoolsize", "");
                    conf.addProperty("org.wso2.ws.dataservice.autocommit", "");

                } else if ("EXCEL".equals(selectedType)) {
                    conf.addProperty("excel_datasource", "");

                } else if ("CSV".equals(selectedType)) {
                    conf.addProperty("csv_datasource", "");
                    conf.addProperty("csv_columnseperator", "");
                    conf.addProperty("csv_columns", "");
                    conf.addProperty("csv_columnordinal", "");
                    conf.addProperty("csv_startingrow", "");
                    conf.addProperty("csv_maxrowcount", "");
                    conf.addProperty("csv_hasheader", "");

                } else if ("JNDIDatasource".equals(selectedType)) {
                    conf.addProperty("jndi_context_class", "");
                    conf.addProperty("jndi_provider_url", "");
                    conf.addProperty("jndi_resource_name", "");
                    conf.addProperty("jndi_username", "");
                    conf.addProperty("jndi_password", "");

                }
               dataService.setConfig(conf);
               }
        }
    }

    String serviceName = request.getParameter("serviceName");

    Iterator propertyIterator = null;
    String dataSourceType = "";
    String rdbmsEngineType = "#";
    try {
        if (configId != null && configId.trim().length() > 0) {
            Config dsConfig = dataService.getConfig(configId);
            if (config != null) {
                dataSourceType = dsConfig.getDataSourceType();
                ArrayList configProperties = dsConfig.getProperties();
                propertyIterator = configProperties.iterator();
                if("RDBMS".equals(dataSourceType)){
                    String jdbcUrl = dsConfig.getPropertyValue(DBConstants.PROTOCOL);
                    if(jdbcUrl != null){
                        rdbmsEngineType = Utils.getRDBMSEngine(jdbcUrl);
                    }
                }
            }
        } else {
            configId = "";
        }        
    } catch (Exception e) {
%>
<jsp:forward page="../admin/error.jsp"/>
<%
    }
%>
<div id="middle">
    <h2>
        <%
           if(!configId.equals("") && flag.equals("")){
        %>
        <fmt:message key="edit.data.source"/><%out.write("("+configId+")");%>
        <%}else{%>
        <fmt:message key="add.new.datasource"/>
        <%}%>
    </h2>

    <div id="workArea">
        <form method="post" action="dataSourceProcessor.jsp" name="dataForm"
              onsubmit="return validateAddDataSourceForm();">
<table class="styledLeft">
<tr><td>
            <table class="normal">
                <tr>
                    <td><fmt:message key="datasource.id"/><font color="red">*</font></td>
                    <td>
                    <%if(readOnly){%>
                    <input type="text" id="datasourceId" name="datasourceId" value="<%=configId%>" readonly="readonly"/>                    
                    <%}else{%>
                    <input type="text" id="datasourceId" name="datasourceId" value="<%=configId%>"/>                    
                    <%}%>
                    </td>
                </tr>
                <tr>
                    <td><label><fmt:message key="dataservices.data.source.type"/><font
                            color="red">*</font></label>
                    </td>
                    <td>
                        <select id="datasourceType" name="datasourceType"
                                onchange="javascript:location.href = 'addDataSource.jsp?selectedType='+this.options[this.selectedIndex].value+'&configId='+document.getElementById('datasourceId').value+'&flag=edit';return false;">
                            <%  if (dataSourceType.equals("")) { %>
                            <option value="" selected="selected">--SELECT--</option>
                            <%
                            } else {%>
                            <option value="">--SELECT--</option>
                            <%}%>

                            <%
                                if (dataSourceType.equals("RDBMS")) {
                            %>
                            <option value="RDBMS" selected="selected">RDBMS</option>
                            <%
                            } else {%>
                            <option value="RDBMS">RDBMS</option>
                            <%}%>


                            <%
                                if (dataSourceType.equals("CSV")) {
                            %>
                            <option value="CSV" selected="selected">CSV</option>
                            <%
                            } else {%>
                            <option value="CSV">CSV</option>
                            <%}%>


                            <%
                                if (dataSourceType.equals("EXCEL")) {
                            %>
                            <option value="EXCEL" selected="selected">EXCEL</option>
                            <%
                            } else {%>
                            <option value="EXCEL">EXCEL</option>
                            <%}%>


                            <%  if (dataSourceType.equals("JNDI")) { %>
                            <option value="JNDIDatasource" selected="selected">JNDI Datasource</option>
                            <%
                            } else {%>
                            <option value="JNDIDatasource">JNDI Datasource</option>
                            <%}%>
                        </select></td>
                </tr>
                <% if("RDBMS".equals(dataSourceType)){%>
                <tr>
                    <td><label><fmt:message key="datasource.database.engine"/><font
                            color="red">*</font></label></td>                            
                    <td>
                        <select name="databaseEngine" id="databaseEngine" onchange="javascript:setJDBCValues(this,document);return false;">
                            <%if("#".equals(rdbmsEngineType)){%>
                             <option value="#" selected="selected">--SELECT--</option>
                            <%}else{%>
                            <option value="#">--SELECT--</option>
                            <%}%>

                            <%if("mysql".equals(rdbmsEngineType)){%>
                            <option selected="selected" value="jdbc:mysql://[machine-name/ip]:[port]/[database-name]#com.mysql.jdbc.Driver">MySQL</option>
                            <%}else{%>
                            <option value="jdbc:mysql://[machine-name/ip]:[port]/[database-name]#com.mysql.jdbc.Driver">MySQL</option>
                            <%}%>

                            <%if("derby".equals(rdbmsEngineType)){%>
                             <option selected="selected" value="jdbc:derby:[path-to-data-file]#org.apache.derby.jdbc.EmbeddedDriver">Apache Derby</option>
                            <%}else{%>
                             <option value="jdbc:derby:[path-to-data-file]#org.apache.derby.jdbc.EmbeddedDriver">Apache Derby</option>
                            <%}%>

                            <%if("mssqlserver".equals(rdbmsEngineType)){%>
                             <option selected="selected" value="jdbc:sqlserver://[HOST]:[PORT1433];databaseName#com.microsoft.sqlserver.jdbc.SQLServerDriver">Microsoft SQL Server</option>
                            <%}else{%>
                             <option value="jdbc:sqlserver://[HOST]:[PORT1433];databaseName=[DB]#com.microsoft.sqlserver.jdbc.SQLServerDriver">Microsoft SQL Server</option>
                            <%}%>

                            <%if("oracle".equals(rdbmsEngineType)){%>
                             <option selected="selected" value="jdbc:oracle:[drivertype]:[username/password]@[host]:[port]/[database]#oracle.jdbc.driver.OracleDriver">Oracle</option>
                            <%}else{%>
                             <option value="jdbc:oracle:[drivertype]:[username/password]@[host]:[port]/[database]#oracle.jdbc.driver.OracleDriver">Oracle</option>
                            <%}%>

                            <%if("db2".equals(rdbmsEngineType)){%>
                             <option selected="selected" value="jdbc:db2:[database]#com.ibm.db2.jcc.DB2Driver">IBM DB2</option>
                            <%}else{%>
                             <option value="jdbc:db2:[database]#com.ibm.db2.jcc.DB2Driver">IBM DB2</option>
                            <%}%>

                            <%if("hsqldb".equals(rdbmsEngineType)){%>
                             <option selected="selected" value="jdbc:hsqldb:[path]#org.hsqldb.jdbcDriver">HSQLDB</option>
                            <%}else{%>
                             <option value="jdbc:hsqldb:[path]#org.hsqldb.jdbcDriver">HSQLDB</option>
                            <%}%>

                            <%if("informix-sqli".equals(rdbmsEngineType)){%>
                             <option  selected="selected" value="jdbc:informix-sqli://[HOST]:[PORT]/[database]:INFORMIXSERVER=[server-name]#com.informix.jdbc.IfxDriver">Informix</option>
                            <%}else{%>
                             <option value="jdbc:informix-sqli://[HOST]:[PORT]/[database]:INFORMIXSERVER=[server-name]#com.informix.jdbc.IfxDriver">Informix</option>
                            <%}%>

                            <%if("postgresql".equals(rdbmsEngineType)){%>
                             <option  selected="selected" value="jdbc:postgresql://[HOST]:[PORT5432]/[database]#org.postgresql.Driver">PostgreSQL</option>
                            <%}else{%>
                             <option value="jdbc:postgresql://[HOST]:[PORT5432]/[database]#org.postgresql.Driver">PostgreSQL</option>
                            <%}%>

                            <%if("sybase".equals(rdbmsEngineType)){%>
                             <option  selected="selected" value="jdbc:sybase:Tds:[HOST]:[PORT2048]/[database]#com.sybase.jdbc3.jdbc.SybDriver">Sybase ASE</option>
                            <%}else{%>
                             <option value="jdbc:sybase:Tds:[HOST]:[PORT2048]/[database]#com.sybase.jdbc3.jdbc.SybDriver">Sybase ASE</option>
                            <%}%>

                             <%if("h2".equals(rdbmsEngineType)){%>
                             <option  selected="selected" value="jdbc:h2:tcp:[HOST]:[PORT]/[database]#org.h2.Driver">H2</option>
                            <%}else{%>
                             <option value="jdbc:h2:tcp:[HOST]:[PORT]/[database]#org.h2.Driver">H2</option>
                            <%}%>

                             <option value="Generic#Generic">Generic</option>
                       </select>
                     </td>
                 </tr>                    
                <%}%>

                <%
                    if (propertyIterator != null) {
                        while (propertyIterator.hasNext()) {
                            Property property = (Property) propertyIterator.next();
                            String propertyName = property.getName().toString();
                            String propertyValue = property.getValue();
                %>
                <tr>
                    <td><fmt:message key="<%=propertyName%>"/></td>
                     <td>
                        <% if(propertyName.equals("org.wso2.ws.dataservice.autocommit")){ %>
                        <select id="<%=propertyName%>" name="<%=propertyName%>">
                            <% if(propertyValue.equals("")){ %>
                               <option value="" selected="selected">--SELECT--</option>
                            <% }else{ %>
                               <option value="">--SELECT--</option>
                            <% } %>

                            <% if(propertyValue.equals("true")){ %>
                               <option value="true" selected="selected">true</option>
                            <% }else{ %>
                               <option value="true">true</option>
                            <% } %>

                            <% if(propertyValue.equals("false")){ %>
                               <option value="false" selected="selected">false</option>
                            <% }else{ %>
                               <option value="false">false</option>
                            <% } %>
                        </select>
                        <% }else if(propertyName.equals("csv_hasheader")){ %>
                        <select id="<%=propertyName%>" name="<%=propertyName%>">
                          <% if(propertyValue.equals("")){ %>
                               <option value="" selected="selected">--SELECT--</option>
                            <% }else{ %>
                               <option value="">--SELECT--</option>
                            <% } %>

                            <% if(propertyValue.equals("true")){ %>
                               <option value="true" selected="selected">true</option>
                            <% }else{ %>
                               <option value="true">true</option>
                            <% } %>

                            <% if(propertyValue.equals("false")){ %>
                               <option value="false" selected="selected">false</option>
                            <% }else{ %>
                               <option value="false">false</option>
                            <% } %>
                        </select>
                        <% } else{    %>
                        <input type="text" size="50" id="<%=propertyName%>" name="<%=propertyName%>" value="<%=propertyValue%>"/>
                        <% } %>
                    </td>
                </tr>
                <%
                        }
                    }
                %>
</table>
</td></tr>
                <tr>
                    <td class="buttonRow">
                    <%if("RDBMS".equals(dataSourceType)){%>
                    <div id="connectionTestMsgDiv" style="display: none;"></div>
                    <input class="button" type="button" value="<fmt:message key="datasource.test.connection"/>" onclick="testConnection();return false;"/>
                    <script type="text/javascript">
                    function displayMsg(msg){
                    CARBON.showInfoDialog(msg);
                    }
                     
                    function testConnection() {
                     var driver = document.getElementById('org.wso2.ws.dataservice.driver').value;
                     var jdbcUrl = document.getElementById('org.wso2.ws.dataservice.protocol').value;
                     var userName = document.getElementById('org.wso2.ws.dataservice.user').value;
                     var password = document.getElementById('org.wso2.ws.dataservice.password').value;
                     
                     var url = 'connection_test_ajaxprocessor.jsp?driver='+driver+'&jdbcUrl='+jdbcUrl+'&userName='+userName+'&password='+password;
                     jQuery('#connectionTestMsgDiv').load(url,displayMsg);                  
                     return false;
                    }
                    </script>
                    
                    <%} %>                    
                    <input class="button" type="submit" value="<fmt:message key="save"/>"/>
                    <input class="button" type="button" value="<fmt:message key="cancel"/>" onclick="location.href = 'dataSources.jsp'"/>
                    </td>
                </tr>
            </table>
        </form>
    </div>
</div>
</fmt:bundle>