<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib uri="http://wso2.org/projects/carbon/taglibs/carbontags.jar" prefix="carbon" %>
<%@ page import="org.wso2.carbon.utils.ServerConstants" %>
<%@ page import="org.apache.axis2.context.ConfigurationContext" %>
<%@ page import="org.wso2.carbon.ui.CarbonUIUtil" %>
<%@ page import="org.wso2.carbon.CarbonConstants" %>
<%@ page import="java.util.Iterator" %>
<%@ page import="java.util.ArrayList" %>
<%@ page import="org.wso2.carbon.dataservices.ui.beans.*" %>
<jsp:include page="../dialog/display_messages.jsp"/>

<fmt:bundle basename="org.wso2.carbon.dataservices.ui.i18n.Resources">
<!-- 
<carbon:breadcrumb
        label="Add Query"
        resourceBundle="org.wso2.carbon.dataservices.ui.i18n.Resources"
        topPage="false"
        request="<%=request%>"/>
        -->
<jsp:useBean id="dataService" class="org.wso2.carbon.dataservices.ui.beans.Data" scope="session"></jsp:useBean>
<script type="text/javascript" src="js/ui-validations.js"></script>
<%
    String queryId = null;
    Query query = null;
    String useConfig = "#";
    String datasourceType = "";
    String wrapperElementName = "";
    String rowName = "";
    String resultNamespace = "";
    String sql = null;
    String url = null;
    String workBookName = null;
    boolean headersAvailable = false;
    int startingRow = 0;
    int maxRowCount = 0;
    boolean readOnly = false;
    try {
        queryId = request.getParameter("queryId");
        if (queryId != null) {
        	readOnly = true;
            query = dataService.getQuery(queryId);
            useConfig = query.getConfigToUse();
            sql = query.getSql();
            Config c = dataService.getConfig(useConfig);
            if (c != null) {
                datasourceType = c.getDataSourceType();
            }
            Result result = query.getResult();            
            if (result != null) {
                wrapperElementName = result.getResultWrapper();
                rowName = result.getRowName();
                resultNamespace = result.getNamespace();
            }
            if(query.getExcel() != null){
                ExcelQuery excel = query.getExcel();
                workBookName = excel.getWorkBookName();
                startingRow = excel.getStartingRow();
                maxRowCount = excel.getMaxRowCount();
                headersAvailable = excel.hasHeaders();
            }
        }
      sql = (sql == null) ? "" : sql;  
      wrapperElementName = (wrapperElementName == null) ? "" : wrapperElementName;
      rowName = (rowName == null) ? "" : rowName;
      resultNamespace = (resultNamespace == null) ? "" : resultNamespace;
      workBookName = (workBookName == null) ? "" : workBookName;      
    } catch (Exception e) {
%>
<%--<jsp:forward page="../admin/error.jsp"/>--%>
<%
    }
%>
<div id="middle">
<h2><%if(readOnly){%>
<fmt:message key="edit.query"/>	
<%}else{%>
<fmt:message key="add.new.query"/>	
<%}%></h2>

<div id="workArea">
<form method="post" action="" name="dataForm"
      onsubmit="return validateAddQueryForm();" id="dataForm">

<input type="hidden" id="buttonAction"/>

<%
    ArrayList<Config> configs = dataService.getConfigs();
    if (configs != null && configs.size() > 0) {
        //iterate through all the configs & store config's datasource type as
        //a hidden field
        Iterator<Config> itrConfigs = configs.iterator();
        while (itrConfigs.hasNext()) {
            Config c = itrConfigs.next();
            if (c != null) {
%>
<input type="hidden" id="<%=c.getId()%>" value="<%=c.getDataSourceType()%>"/>
<%
            }
        }
    }
%>
<table class="styledLeft">
<tr>
    <td>
        <table class="normal">
            <tr>
                <td>
                    <table class="normal">

                        <tr>
                            <td><fmt:message key="query.id"/><font color="red">*</font></td>
                            <td>
                            <%if(readOnly){%>
                            <input type="text" name="queryId" id="queryId" readonly="readonly" value="<%=(queryId != null)?queryId:""%>"/>                            
                            <%}else{%>
                            <input type="text" name="queryId" id="queryId" value="<%=(queryId != null)?queryId:""%>"/>
                            <%}%>
                            </td>
                        </tr>
                        <tr>
                            <td><fmt:message key="query.datasource"/><font color="red">*</font></td>
                            <td><select id="datasource" name="datasource" onchange="showTables(this,document);return false;"/>
                                <option value="#">--SELECT--</option>
                                <%
                                    if (configs != null && configs.size() > 0) {
                                        Iterator iterator = configs.iterator();
                                        Config conf = new Config();
                                        while (iterator.hasNext()) {
                                            Config dsConfig = (Config) iterator.next();
                                            if (dsConfig != null) {

                                                if (dsConfig.getId().equals(useConfig)) {
                                %>
                                <option value="<%=dsConfig.getId()%>" selected="selected">
                                    <%=dsConfig.getId()%>
                                </option>
                                <%} else {%>
                                <option value="<%=dsConfig.getId()%>">
                                    <%=dsConfig.getId()%>
                                </option>
                                <%
                                                }
                                            }
                                        }
                                    }
                                %>

                            </td>
                        </tr>
                    </table>
                  </td>
                </tr>
                <tr id="RDBMSnJNDIRow" style="<%=(datasourceType.equals("RDBMS") || datasourceType.equals("JNDI"))?"":"display:none"%>">
                   <td>
                     <table>
                       <tr>
                         <td align="left"><fmt:message key="datasources.query.sql"/><font color='red'>*</font></td>
                         <td><textarea cols="50" rows="8" id="sql" name="sql"><%=(query != null) ? sql : ""%></textarea></td>
                       </tr>
                     </table>
                   </td> 
                </tr>                               
                <tr id="InputMappingRow" style="<%=(datasourceType.equals("RDBMS") || datasourceType.equals("JNDI"))?"":"display:none"%>">
                  <td>
					<table class="styledInner" cellspacing="0" id="existingInputMappingsTable">
						<%
						if(query != null){
							Param[] params = query.getParams();
							if (params != null && params.length > 0) {
								String inputParamName = "";
								String sqlType = "";
						%>
						<tr>
							<td><b><fmt:message key="datasources.mapping.name" /></b></td>
							<td><b><fmt:message key="datasources.sql.type" /></b></td>
							<td><b><fmt:message key="datasources.action" /></b></td>
						</tr>
						<%
								for (int a = 0; a < params.length; a++) {
									inputParamName = (params[a].getName() == null) ? "" : params[a].getName();
									sqlType = (params[a].getSqlType() == null) ? "" : params[a].getSqlType();
						%>
						<tr>
                            <input type="hidden" id="<%=inputParamName%>" name="<%=inputParamName%>" value="<%=inputParamName%>" />
                            <input type="hidden" id="<%=sqlType%>" name="<%=sqlType%>" value="<%=sqlType%>" />
                            <td><%=inputParamName%></td>
							<td><%=sqlType%></td>
							<td><a class="icon-link"
								style="background-image: url(../admin/images/edit.gif);"
								href="addInputMapping.jsp?paramName=<%=inputParamName%>&queryId=<%=queryId%>"><fmt:message
								key="edit" /></a> <a class="icon-link"
								style="background-image: url(../admin/images/delete.gif);"
                                onclick="deleteInputMappingsFromAddQuery(document.getElementById('<%=inputParamName%>').value,document.getElementById('<%=sqlType%>').value,document.getElementById('queryId').value);"
                                href="#"><fmt:message
								key="delete" /></a></td>
						</tr>
						<%
							}
							} else {
						%>
						<tr>
							<td colspan="3"><label><fmt:message
								key="datasources.no.inputmapping" /></label></td>
						</tr>
						<%
							}
						}else{
							//new query, hence no input mappings
							%>
							<tr>
								<td colspan="3"><label><fmt:message
									key="datasources.no.inputmapping" /></label></td>
							</tr>
							<%							
						}
						%>
					</table>
                   </td>
                 </tr>
                 <tr id="InputMappingButtonRow" style="<%=(datasourceType.equals("RDBMS") || datasourceType.equals("JNDI"))?"":"display:none"%>">
                    <td>
                       <input type="submit" id="newInputMapping" value="Add New Input Mapping" onclick="document.dataForm.action='queryProcessor.jsp?flag=inputMapping'"></td>
                 </tr>

                 <tr id="ExcelRow" style="<%=datasourceType.equals("EXCEL") ? "":"display:none"%>">
                    <td>
                        <table class="normal">                            
                            <tr>
                                <td colspan="2"><b><fmt:message key="dataservices.header.for.excel"/></b></td>
                            </tr>
                            <tr>
                                <td><label><fmt:message key="dataservicesworkbook.name"/><font color="red">*</font></label></td>
                                <td><input value="<%=workBookName%>" id="txtExcelWorkbookName" name="txtExcelWorkbookName" size="30" type="text"></td>
                            </tr>
                            <tr>
                                <td><label><fmt:message key="dataservices.start.reading.from"/><font color="red">*</font></label></td>
                                <td><input value="<%=startingRow%>" id="txtExcelStartingRow" name="txtExcelStartingRow" size="30" type="text"></td>
                            </tr>
                            <tr>
                                <td><label><fmt:message key="dataservices.rows.to.read"/><font color="red">*</font></label></td>
                                <td><input value="<%=maxRowCount%>" id="txtExcelMaxRowCount" name="txtExcelMaxRowCount" size="30" type="text"></td>
                            </tr>
                            <tr>
                                <td><label><fmt:message key="dataservices.headers.available"/><font color="red">*</font></label></td>
                                <td><select id="txtExcelHeaderColumns" name="txtExcelHeaderColumns">
                                    <% if(headersAvailable){ %>
                                    <option value="true" selected="selected">true</option>
                                    <option value="false">false</option>
                                    <% }else{ %>
                                    <option value="true">true</option>
                                    <option value="false" selected="selected">false</option>                                    
                                    <% } %>
                                </select></td>
                            </tr>
                        </table>
                    </td>
                 </tr>
                 <tr>
                    <td>
                        <table class="normal">
                            <tr>
                                <td colspan="2"><label><b><fmt:message key="datasources.result.output.mapping"/></b></label></td>                                
                            </tr>
                            <tr>
                                <td><label><fmt:message key="datasources.grouped.by.element"/></label></td>
                                <td>
                                    <input value="<%=wrapperElementName%>" id="txtDataServiceWrapElement"
                                           name="txtDataServiceWrapElement" size="30" type="text">
                            </tr>
                            <tr>
                                <td><label><fmt:message key="datasources.row.name"/></label></td>
                                <td><input value="<%=rowName%>" id="txtDataServiceRowName"
                                           name="txtDataServiceRowName" size="30" type="text"></td>
                            </tr>
                            <tr>
                                <td><label><fmt:message key="datasources.row.namespace"/></label></td>
                                <td><input value="<%=resultNamespace%>" id="txtDataServiceRowNamespace"
                                           name="txtDataServiceRowNamespace" size="30" type="text"></td>
                            </tr>
                        </table>
                    </td>
                 </tr>

                 <tr>
                    <td>
                        <table class="styledInner" cellspacing="0" id="existingOutputMappingsTable">
                            <%  if (query != null) {
                                    Result result = query.getResult();
                                    if (result != null) {
                                        ArrayList<Element> elements = result.getElements();
                                        Iterator itrElements = elements.iterator();
                                        if(itrElements.hasNext()){
                            %>
                            <tr>
                                <td><b><fmt:message key="dataservices.element.name"/></b></td>
                                <td><b><fmt:message key="dataservices.sql.column.name"/></b></td>
                                <td><b><fmt:message key="data.services.mapping.type"/></b></td>
                                <td><b><fmt:message key="actions1"/></b></td>
                            </tr>

                            <%
                                }
                                        ArrayList<Attribute> attributes = result.getAttributes();
                                        ArrayList<CallQuery> callQueries = result.getCallQueries();
                                        if (elements != null) {
                                            while (itrElements.hasNext()) {
                                                Element element = (Element) itrElements.next();
                            %>
                            <tr>
                                <input type="hidden" id="<%=element.getName()%>" name="<%=element.getName()%>" value="<%=element.getName()%>" />
                                <td><%=element.getName()%>
                                </td>
                                <td><%=element.getColumn()%>
                                </td>
                                <td>element</td>
                                <td>
                                    <a class="icon-link" style="background-image:url(../admin/images/edit.gif);" href="addOutputMapping.jsp?queryId=<%=queryId%>&name=<%=element.getName()%>&column=<%=element.getColumn()%>&edit=<%=element.getName()%>&mappingType=element&flag=save"><fmt:message
                                            key="edit"/></a>
                                    <a class="icon-link" style="background-image:url(../admin/images/delete.gif);" href="#" onclick="deleteOutputMappingsFromAddQuery(document.getElementById('queryId').value,document.getElementById('<%=element.getName()%>').value,'element');"><fmt:message
                                            key="delete"/></a>
                                </td>
                            </tr>

                            <%
                                    }
                                }
                                if (attributes != null) {
                                    Iterator itrAttributes = attributes.iterator();
                                    while (itrAttributes.hasNext()) {
                                        Attribute attribute = (Attribute) itrAttributes.next();
                            %>
                            <tr>
                                <input type="hidden" id="<%=attribute.getName()%>" name="<%=attribute.getName()%>" value="<%=attribute.getName()%>" />
                                <td><%=attribute.getName()%>
                                </td>
                                <td><%=attribute.getColumn()%>
                                </td>
                                <td>attribute</td>
                                <td>
                                    <a class="icon-link" style="background-image:url(../admin/images/edit.gif);" href="addOutputMapping.jsp?queryId=<%=queryId%>&name=<%=attribute.getName()%>&column=<%=attribute.getColumn()%>&edit=<%=attribute.getName()%>&mappingType=attribute&flag=save"><fmt:message
                                            key="edit"/></a>
                                    <a class="icon-link" style="background-image:url(../admin/images/delete.gif);" href="#" onclick="deleteOutputMappingsFromAddQuery(document.getElementById('queryId').value,document.getElementById('<%=attribute.getName()%>').value,'attribute');"><fmt:message
                                            key="delete"/></a>
                                </td>
                            </tr>
                            <%
                                    }
                                }
                                if (callQueries != null) {
                                    Iterator itrCallQueries = callQueries.iterator();
                                    if(itrCallQueries.hasNext()){
                                	%>
                                    <tr>
                                        <td colspan="4"></td>
                                    </tr>
                                    <tr>
                                        <td colspan="3"><b><fmt:message key="query.id"/></b></td>
                                        <td><b><fmt:message key="actions1"/></b></td>
                                    </tr>
                                       	<%
                                               }                                    
                                    while (itrCallQueries.hasNext()) {
                                        CallQuery callQuery = (CallQuery) itrCallQueries.next();
                            %>
                            <tr>
                                <input type="hidden" id="<%=callQuery.getHref()%>" name="<%=callQuery.getHref()%>" value="<%=callQuery.getHref()%>" />
                                <td><%=callQuery.getHref()%>
                                </td>
                                <td></td>
                                <td>query</td>
                                <td>
                                    <%--<a class="icon-link" style="background-image:url(../admin/images/edit.gif);" href="addOutputMapping.jsp?queryId=<%=queryId%>&selectedQuery=<%=callQuery.getHref()%>&edit=edit&mappingType=query&flag=save">--%>
                                            <a class="icon-link" style="background-image:url(../admin/images/edit.gif);" href="addOutputMapping.jsp?queryId=<%=queryId%>&selectedQuery=<%=callQuery.getHref()%>&edit=<%=callQuery.getHref()%>&mappingType=query&flag=save"><fmt:message
                                            key="edit"/></a>
                                    <a class="icon-link" style="background-image:url(../admin/images/delete.gif);" href="#" onclick="deleteOutputMappingsFromAddQuery(document.getElementById('queryId').value,document.getElementById('<%=callQuery.getHref()%>').value,'query');"><fmt:message
                                            key="delete"/></a>
                                </td>
                            </tr>
                            <%
                                            }
                                        }

                                    }

                                }
                              if(query == null || query.getResult() == null || ((query.getResult().getElements() == null ||query.getResult().getElements().size() == 0) && (query.getResult().getAttributes() == null || query.getResult().getAttributes().size() == 0) && (query.getResult().getCallQueries() == null || query.getResult().getCallQueries().size() == 0))){
                            %>
                             <tr id="noOutputmappings"><td colspan="2"><fmt:message key="datasources.currently.there.are.no.output.mappings.present.for.this.query"/></td> </tr>
                            <%
                                }
                            %>
                        </table>
                    </td>
                 </tr>
                 <tr>
                    <td><input type="submit" id="newOutputMapping" onclick="return validateOutputMappingFields(<%=readOnly%>);"
                               value="Add New Output Mapping"></td>
                 </tr>
           </table>
        </td>
     </tr>
     <tr>
        <td class="buttonRow" ><input class="button"
                                                 type="submit" value="<fmt:message key="save"/>" onclick="document.dataForm.action='queryProcessor.jsp?flag=save&edit=<%=readOnly%>';return validateAddQueryFormSave();"/> <input
                class="button" type="button" value="<fmt:message key="cancel"/>"
                onclick="location.href = 'queries.jsp'"/></td>
     </tr>
    </table>
  </form>
</div>
</div>
     <script type="text/javascript">
        alternateTableRows('existingInputMappingsTable', 'tableEvenRow', 'tableOddRow');
        alternateTableRows('existingOutputMappingsTable', 'tableEvenRow', 'tableOddRow');
    </script>
</fmt:bundle>