<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib uri="http://wso2.org/projects/carbon/taglibs/carbontags.jar" prefix="carbon" %>
<%@ page import="org.wso2.carbon.utils.ServerConstants" %>
<%@ page import="org.apache.axis2.context.ConfigurationContext" %>
<%@ page import="org.wso2.carbon.ui.CarbonUIUtil" %>
<%@ page import="org.wso2.carbon.CarbonConstants" %>
<%@ page import="org.wso2.carbon.dataservices.ui.beans.Config" %>
<%@ page import="java.util.ArrayList" %>
<%@ page import="java.util.Iterator" %>

<jsp:include page="../dialog/display_messages.jsp"/>

<fmt:bundle basename="org.wso2.carbon.dataservices.ui.i18n.Resources">
<carbon:breadcrumb 
		label="Data Sources"
		resourceBundle="org.wso2.carbon.dataservices.ui.i18n.Resources"
		topPage="false" 
		request="<%=request%>" />
<jsp:useBean id="dataService" class="org.wso2.carbon.dataservices.ui.beans.Data" scope="session"></jsp:useBean>
<script type="text/javascript" src="js/ui-validations.js"></script>    
<%
    //retrieve value from serviceDetails.jsp
    String description = request.getParameter("description");
	String serviceName = request.getParameter("serviceName");
    boolean finishEnable = false;
    try {
        if (serviceName != null && serviceName.trim().length() > 0) {
            dataService.setName(serviceName);
        }else{
            serviceName = dataService.getName();
        }
        if (description != null && description.trim().length() > 0) {
            dataService.setDescription(description);
        }
     } catch (Exception e) {
%>
     <jsp:forward page="../admin/error.jsp"/>
<%
	}
%>

<div id="middle">
<h2><fmt:message key="datasources.heading"/></h2>
	<div id="workArea">
	<form method="post" action="queries.jsp" name="dataForm"
		onsubmit="return validateDataSourcesForm();">       
        <table class="styledLeft" id="datasource-table">
            <%
                ArrayList<Config> configs = dataService.getConfigs();
                if (configs != null && configs.size() > 0) {
                    String configId = null;
            %>
            <thead>
            <tr>
                <th width="20%"><fmt:message key="datasource.name"/></th>
                <%--<th width="20%"><fmt:message key="datasource.type"/></th>--%>
                <th width="60%"><fmt:message key="actions"/></th>
            </tr>
            </thead>
            <tbody>

            <%
                Iterator iterator = configs.iterator();
                while (iterator.hasNext()) {
                    Config dsConfig = (Config) iterator.next();
                    if (dsConfig != null) {
                        finishEnable = true;
                        configId = dsConfig.getId();
            %>

            <tr>
                <td><%=configId%>
                </td>
                <input type="hidden" id="<%=configId%>" name="configId" value="<%=configId%>" />
                <%--<td><%=dsConfig.getDataSourceType()%>--%>
                <%--</td>--%>
                <td>
                    <a class="icon-link" style="background-image:url(../admin/images/edit.gif);" href="addDataSource.jsp?configId=<%=configId%>"><fmt:message
                            key="edit.datasource"/></a>
                    <a class="icon-link" style="background-image:url(../admin/images/delete.gif);" onclick="deleteDatasource(document.getElementById('<%=configId%>').value);" href="#"><fmt:message
                            key="delete.datasource"/></a>
                </td>
            </tr>

            <%

                        }
                    }
                }               
            %>
            <tr>
                <td colspan="2">
                    <a class="icon-link" style="background-image:url(../admin/images/add.gif);"
                       href="addDataSource.jsp"><fmt:message
                            key="add.new.datasource"/></a>
                </td>
            </tr>
            <tr>
                <td class="buttonRow" colspan="2"><%--<input class="button" type="button"
                                                         value="< <fmt:message key="back"/>" onclick="location.href = 'serviceDetails.jsp?serviceName=<%=serviceName%>' "/> --%><input class="button" type="submit"
                                                         value="<fmt:message key="next"/> >"/>
                    <% if(finishEnable){ %>
                        <input class="button" type="button" value="<fmt:message key="finish"/>" onclick="location.href = 'wizardDoneProcessor.jsp'"/>
                    <% }else{ %>
                        <input class="button" type="button" value="<fmt:message key="finish"/>" disabled="disabled"  onclick="location.href = 'wizardDoneProcessor.jsp'"/>
                    <% } %>
                    <input
                            class="button" type="button" value="<fmt:message key="cancel"/>"
                            onclick="location.href = '../service-mgt/index.jsp'"/></td>
            </tr>
            </tbody>
        </table>
    </form>
	</div>
	</div>
</fmt:bundle>