<%@ page import="org.wso2.carbon.dataservices.DBConstants" %>
<%@ page import="org.apache.axis2.databinding.utils.BeanUtil" %>
<%@ page import="org.wso2.carbon.dataservices.ui.beans.*" %>
<%@ page import="java.util.ArrayList" %>
<%@ page import="java.util.Iterator" %>
<%@ page import="org.wso2.carbon.ui.CarbonUIMessage" %>

<jsp:include page="../dialog/display_messages.jsp"/>
<jsp:useBean id="dataService" class="org.wso2.carbon.dataservices.ui.beans.Data" scope="session"/>
<%
    //retrieve form values set in addQuery.jsp page
    String serviceName = request.getParameter("serviceName");
    String queryId = request.getParameter("queryId");
    String datasource = request.getParameter("datasource");
    String sql = request.getParameter("sql");
    String flag = request.getParameter("flag");
    String rowName = request.getParameter("txtDataServiceRowName");
    String nameSpace = request.getParameter("txtDataServiceRowNamespace");
    String element = request.getParameter("txtDataServiceWrapElement");
    String workBookName = request.getParameter("txtExcelWorkbookName");
    String startingRow = request.getParameter("txtExcelStartingRow");
    String maxRowCount = request.getParameter("txtExcelMaxRowCount");
    String headerColumns = request.getParameter("txtExcelHeaderColumns");
    String edit = request.getParameter("edit");
    edit = (edit == null) ? "" : edit ;
    ArrayList<Query> queryList = dataService.getQueries();
    Query query ;
    Result result;
    String forwardTo = "";
    boolean remove = true;
    if(queryId != null){
       query = dataService.getQuery(queryId);
       //if have existing queries
       if(query != null){
           if(edit.equals("false")){
             //checking for queries with the same query Id.
             String message = "Please enter a different Query ID. A Query ID called "+queryId+" already exists.";
             CarbonUIMessage.sendCarbonUIMessage(message, CarbonUIMessage.ERROR, request);
             forwardTo = "addQuery.jsp";
             flag = "error";
           }
           if(flag.equals("delete")){
             ArrayList<Operation> operation = dataService.getOperations();
             ArrayList<Resource> resource = dataService.getResources();
             if(operation != null){
                 // checking for operations which has used the query before deleting.
                 for(int a=0; a < operation.size(); a++){
                     if(queryId.equals(operation.get(a).getCallQuery().getHref())){
                        String message = "Query Id "+queryId+" has been used by operation(s). Please remove the relevant operation(s) to proceed.";
                        CarbonUIMessage.sendCarbonUIMessage(message, CarbonUIMessage.ERROR, request);
                        forwardTo = "queries.jsp";
                        flag = "error";
                        remove = false;
                     }
                 }
             }
             if(resource != null){
                 for(int a =0; a < resource.size(); a++){
                     // checking for resources which has used the query before deleting.
                     if(queryId.equals(resource.get(a).getCallQuery().getHref())){
                       String message = "Query Id "+queryId+" has been used by resource(s). Please remove the relevant resource(s) to proceed.";
                       CarbonUIMessage.sendCarbonUIMessage(message, CarbonUIMessage.ERROR, request);
                       forwardTo = "queries.jsp";
                       flag = "error";
                       remove = false;
                     }
                 }
             }
             if(remove){
                dataService.removeQuery(query);
             }
           }else{
                query.setId(queryId);
                query.setConfigToUse(datasource);
                Config con = dataService.getConfig(datasource);
                if(con.getDataSourceType().equals("RDBMS")){
                    query.setSql(sql);
                }
               result = query.getResult();
               if(query.getResult() != null){
                   result.setNamespace(nameSpace);
                   result.setResultWrapper(element);
                   result.setRowName(rowName);
               }else{
                   if(!nameSpace.equals("") || !element.equals("") || !rowName.equals("")){
                     result = new Result();
                     result.setNamespace(nameSpace);
                     result.setResultWrapper(element);
                     result.setRowName(rowName);
                     query.setResult(result);  
                   }
               }
            }
        }else{
            query = new Query();
            query.setId(queryId);
            Config con = dataService.getConfig(datasource);
            //query.setConfigToUse(con.getDataSourceType());
           query.setConfigToUse(datasource);
            if(con.getDataSourceType().equals("RDBMS")){
                query.setSql(sql);
            }else if(con.getDataSourceType().equals("EXCEL")){
                ExcelQuery excel = new ExcelQuery();
                excel.setWorkBookName(workBookName);
                excel.setHasHeaders(headerColumns);
                excel.setMaxRowCount(maxRowCount);
                excel.setStartingRow(startingRow);
                query.setExcel(excel);
                excel.buildXML();
            }
            if(!nameSpace.equals("") || !element.equals("") || !rowName.equals("")){
                     result = new Result();
                     result.setNamespace(nameSpace);
                     result.setResultWrapper(element);
                     result.setRowName(rowName);
                     query.setResult(result);

            }           
            dataService.addQuery(query);           
        }
    }  
  
%>
<table style="display:none">
    <tr>
        <td><input id="flag" name="flag" value="<%=flag%>">
        </td>
    </tr>
    <tr><input type="hidden" id="serviceName" value="<%=serviceName%>" /> </tr>
    <tr><input type="hidden" id="datasource" value="<%=datasource%>" /> </tr>
    <tr><input type="hidden" id="queryId" value="<%=queryId%>" /> </tr>
    <tr><input type="hidden" id="sql" value="<%=sql%>" /> </tr>
    <tr><input type="hidden" id="rowName" value="<%=rowName%>" /></tr>
    <tr><input type="hidden" id="ns" value="<%=nameSpace%>" /> </tr>
    <tr><input type="hidden" id="element" value="<%=element%>" /> </tr>
</table>

<script type="text/javascript">
    var flag = document.getElementById('flag').value;
    
    if (flag == 'inputMapping') {
        location.href = 'addInputMapping.jsp?queryId='+document.getElementById('queryId').value;
    }
    else if(flag == 'save' || flag == 'delete'){
        location.href = 'queries.jsp?serviceName='+document.getElementById('serviceName').value;
    }
    else if (flag == 'outputMapping') {
        location.href = 'addOutputMapping.jsp?queryId='+document.getElementById('queryId').value;
    }else if(flag == "error"){
        location.href = "<%=forwardTo%>";
    }


</script>