<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib uri="http://wso2.org/projects/carbon/taglibs/carbontags.jar" prefix="carbon" %>
<%@ page import="org.wso2.carbon.utils.ServerConstants" %>
<%@ page import="org.apache.axis2.context.ConfigurationContext" %>
<%@ page import="org.wso2.carbon.ui.CarbonUIUtil" %>
<%@ page import="org.wso2.carbon.CarbonConstants" %>
<%@ page import="java.io.InputStream" %>
<%@ page import="org.apache.axiom.om.impl.builder.StAXOMBuilder" %>
<%@ page import="org.apache.axiom.om.OMElement" %>
<%@ page import="org.wso2.carbon.dataservices.ui.beans.Data" %>
<%@page import="org.wso2.carbon.dataservices.ui.DataServiceAdminClient"%>
<%@page import="java.io.ByteArrayInputStream"%>
<%@ page import="org.wso2.carbon.CarbonError" %>
<script type="text/javascript" src="js/ui-validations.js"></script>

<fmt:bundle basename="org.wso2.carbon.dataservices.ui.i18n.Resources">
<carbon:breadcrumb 
		label="Service Details"
		resourceBundle="org.wso2.carbon.dataservices.ui.i18n.Resources"
		topPage="false" 
		request="<%=request%>" />
<%
    String serviceName = request.getParameter("serviceName");
    String description = "";
    if (serviceName != null && serviceName.trim().length() > 0) {
        try {
            String backendServerURL = CarbonUIUtil.getServerURL(config.getServletContext(), session);
            ConfigurationContext configContext =
                    (ConfigurationContext) config.getServletContext().getAttribute(CarbonConstants.CONFIGURATION_CONTEXT);
            String cookie = (String) session.getAttribute(ServerConstants.ADMIN_SERVICE_COOKIE);
            DataServiceAdminClient client = new DataServiceAdminClient(cookie,backendServerURL,configContext);
            String serviceContents = client.getDataServiceContents(serviceName);
            
            InputStream ins = new ByteArrayInputStream(serviceContents.getBytes());
            OMElement configElement = (new StAXOMBuilder(ins)).getDocumentElement();
            configElement.build();
            Data data = new Data();
            data.populate(configElement);
            description = data.getDescription();
            if(description == null){
            	description = "";
            }
            request.getSession().setAttribute("dataService",data);
        } catch (Exception e) {
     	   CarbonError carbonError = new CarbonError();
    	   carbonError.addError("Error occurred while saving data service configuration.");
    	   request.setAttribute(CarbonError.ID, carbonError);        	
%>
<script type="text/javascript">
    location.href = "../admin/error.jsp";
</script>
<%
        }
    }else{
            serviceName = "";
            request.getSession().setAttribute("dataService",null);            
    }
%>
	<div id="middle">
    <h2>
        <%
           if(serviceName != null && !(serviceName.trim().equals(""))){
        %>
        <fmt:message key="service.edit.heading" /><%out.write("("+serviceName+")");%>
        <%}else{%>
        <fmt:message key="service.create.heading" />
        <%}%>
    </h2>
	<div id="workArea">
	<form method="post" action="dataSources.jsp" name="dataForm"
		onsubmit="return validateServiceDetailsForm();">
	<table class="styledLeft" id="dataSources" width="60%">
		<thead>
			<tr>
				<th><fmt:message key="service.details" /></th>
			</tr>
		</thead>
		<tr>
			<td class="formRaw">
			<table class="normal">
				<tr>
					<td><fmt:message key="service.name" /><font color="red">*</font></td>
					<td><% if(!serviceName.equals("")){ %>
                        <input type="text" name="serviceName" id="serviceName" value="<%=serviceName%>" readonly="readonly"/>
                        <% }else{ %>
                        <input type="text" name="serviceName" id="serviceName" value="<%=serviceName%>"/>
                        <% } %>
                    </td>
				</tr>
				<tr>
					<td><fmt:message key="service.description" /></td>
					<td><textarea cols="40" rows="5" name="description"><%=description%></textarea></td>
				</tr>
			</table>
			</td>
		</tr>
		<tr>
			<td class="buttonRow">
			<input class="button" type="submit" value="<fmt:message key="next"/> >" />
			<input class="button" type="button" value="<fmt:message key="cancel"/>"	
				onclick="location.href = '../service-mgt/index.jsp'" />
			</td>
		</tr>
	</table>
	</form>
	</div>
	</div>
</fmt:bundle>
